# Class MOCalculation

java.lang.Object
org.jmol.quantum.QuantumCalculation
org.jmol.quantum.MOCalculation

public class MOCalculation extends QuantumCalculation

## Field Summary

Fields
Modifier and Type
Field
Description
`double[]`
`coeffs`
`double[]`
`EX`
`double[]`
`EY`
`double[]`
`EZ`
`int`
`gaussianPtr`
`float[][]`
`gaussians`
`boolean`
`havePoints`
`int`
`nGaussians`
`static final int`
`NORM_NBO`
`static final int`
`NORM_NONE`
`static final int`
`NORM_NWCHEM`
`static final int`
`NORM_STANDARD`
`int`
`normType`
`static final double`
`ROOT3`

### Fields inherited from class QuantumCalculation

`atomIndex, bohr_per_angstrom, bsExcluded, countsXYZ, doDebug, firstAtomOffset, integration, nX, nY, nZ, originBohr, points, qmAtoms, rangeBohrOrAngstroms, stepBohr, thisAtom, unitFactor, volume, voxelData, voxelDataTemp, X, X2, xBohr, xMax, xMin, Y, Y2, yBohr, yMax, yMin, Z, Z2, zBohr, zMax, zMin`

## Constructor Summary

Constructors
Constructor
Description
`MOCalculation()`

## Method Summary

Modifier and Type
Method
Description
`void`
`calculateElectronDensity()`
`void`
`createCube()`
`double`
`getContractionNormalization(int el, int cpt)`
NWCHEM only
`void`
`initialize(int nX, int nY, int nZ, T3[] points)`
`void`
`process()`
`void`
`processPoints()`
`void`
`setE(double[] EX, double alpha)`
`boolean`
`setupCalculation(Map<String,Object> moData, boolean isSlaters, VolumeData volumeData, BS bsSelected, T3[] xyz, Atom[] atoms, int firstAtomOffset, int[][] dfCoefMaps, float[] moCoefficients, float[] linearCombination, boolean isSquaredLinear, float[][] coefs, T3[] points)`

### Methods inherited from class QuantumCalculation

`getIntegration, initialize0, initializeOnePoint, initializeOnePointQC, processPt, setMinMax, setupCoordinates, setXYZBohr`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### ROOT3

public static final double ROOT3

See Also:
  - Constant Field Values

### EX

public double[] EX

### EY

public double[] EY

### EZ

public double[] EZ

### gaussians

public float[][] gaussians

### gaussianPtr

public int gaussianPtr

### NORM_NONE

public static final int NORM_NONE

See Also:
  - Constant Field Values

### NORM_STANDARD

public static final int NORM_STANDARD

See Also:
  - Constant Field Values

### NORM_NWCHEM

public static final int NORM_NWCHEM

See Also:
  - Constant Field Values

### NORM_NBO

public static final int NORM_NBO

See Also:
  - Constant Field Values

### normType

public int normType

### havePoints

public boolean havePoints

### nGaussians

public int nGaussians

### coeffs

public double[] coeffs

## Constructor Details

### MOCalculation

public MOCalculation()

## Method Details

### setupCalculation

public boolean setupCalculation(Map<String,Object> moData, boolean isSlaters, VolumeData volumeData, BS bsSelected, T3[] xyz, Atom[] atoms, int firstAtomOffset, int[][] dfCoefMaps, float[] moCoefficients, float[] linearCombination, boolean isSquaredLinear, float[][] coefs, T3[] points)

### initialize

public void initialize(int nX, int nY, int nZ, T3[] points)

Overrides:
  `initialize` in class `QuantumCalculation`

### createCube

public void createCube()

Specified by:
  `createCube` in class `QuantumCalculation`

### processPoints

public void processPoints()

Overrides:
  `processPoints` in class `QuantumCalculation`

### process

public void process()

Specified by:
  `process` in class `QuantumCalculation`

### getContractionNormalization

public double getContractionNormalization(int el, int cpt)
NWCHEM only

Parameters:
  `el` -
  `cpt` -
Returns:
  NWCHEM contraction normalization

### setE

public void setE(double[] EX, double alpha)

### calculateElectronDensity

public void calculateElectronDensity()